function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

export function createStore(reducer, props, stateEnhancers) {
  function enhanceState(state) {
    return stateEnhancers.reduce(function (nextState, stateEnhancer) {
      return stateEnhancer(nextState, props);
    }, state);
  }

  var state = enhanceState(props.initialState);
  return {
    getState: function getState() {
      return state;
    },
    send: function send(action, payload) {
      var prevState = _objectSpread({}, state);

      state = enhanceState(reducer(state, {
        type: action,
        props: props,
        payload: payload
      }));
      props.onStateChange({
        state: state,
        prevState: prevState
      });
    }
  };
}