function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { generateAutocompleteId, getItemsCount, noop, getNormalizedSources } from './utils';
export function getDefaultProps(props) {
  var _props$id;

  var environment = typeof window !== 'undefined' ? window : {};
  var plugins = props.plugins || [];
  return _objectSpread(_objectSpread({
    debug: false,
    openOnFocus: false,
    placeholder: '',
    autoFocus: false,
    defaultHighlightedIndex: null,
    enableCompletion: false,
    stallThreshold: 300,
    environment: environment,
    shouldDropdownShow: function shouldDropdownShow(_ref) {
      var state = _ref.state;
      return getItemsCount(state) > 0;
    },
    onStateChange: noop
  }, props), {}, {
    // Since `generateAutocompleteId` triggers a side effect (it increments
    // and internal counter), we don't want to execute it if unnecessary.
    id: (_props$id = props.id) !== null && _props$id !== void 0 ? _props$id : generateAutocompleteId(),
    // The following props need to be deeply defaulted.
    initialState: _objectSpread({
      highlightedIndex: null,
      query: '',
      completion: null,
      suggestions: [],
      isOpen: false,
      status: 'idle',
      statusContext: {},
      context: {}
    }, props.initialState),
    onSubmit: function onSubmit(params) {
      if (props.onSubmit) {
        props.onSubmit(params);
      }

      plugins.forEach(function (plugin) {
        if (plugin.onSubmit) {
          plugin.onSubmit(params);
        }
      });
    },
    getSources: function getSources(options) {
      var getSourcesFromPlugins = plugins.map(function (plugin) {
        return plugin.getSources;
      }).filter(function (getSources) {
        return getSources !== undefined;
      });
      return Promise.all([].concat(_toConsumableArray(getSourcesFromPlugins), [props.getSources]).map(function (getSources) {
        return getNormalizedSources(getSources, options);
      })).then(function (nested) {
        return (// same as `nested.flat()`
          nested.reduce(function (acc, array) {
            acc = acc.concat(array);
            return acc;
          }, [])
        );
      }).then(function (sources) {
        return sources.map(function (source) {
          return _objectSpread(_objectSpread({}, source), {}, {
            onSelect: function onSelect(params) {
              source.onSelect(params);
              plugins.forEach(function (plugin) {
                if (plugin.onSelect) {
                  plugin.onSelect(params);
                }
              });
            }
          });
        });
      });
    },
    navigator: _objectSpread({
      navigate: function navigate(_ref2) {
        var suggestionUrl = _ref2.suggestionUrl;
        environment.location.assign(suggestionUrl);
      },
      navigateNewTab: function navigateNewTab(_ref3) {
        var suggestionUrl = _ref3.suggestionUrl;
        var windowReference = environment.open(suggestionUrl, '_blank', 'noopener');

        if (windowReference) {
          windowReference.focus();
        }
      },
      navigateNewWindow: function navigateNewWindow(_ref4) {
        var suggestionUrl = _ref4.suggestionUrl;
        environment.open(suggestionUrl, '_blank', 'noopener');
      }
    }, props.navigator),
    plugins: plugins
  });
}