import { InternalAutocompleteOptions } from './api';
import { AutocompleteState } from './state';
export interface AutocompleteStore<TItem> {
    getState(): AutocompleteState<TItem>;
    send(action: ActionType, payload: any): void;
}
export declare type Reducer = <TItem>(state: AutocompleteState<TItem>, action: Action<TItem, any>) => AutocompleteState<TItem>;
declare type Action<TItem, TPayload> = {
    type: ActionType;
    props: InternalAutocompleteOptions<TItem>;
    payload: TPayload;
};
declare type ActionType = 'setHighlightedIndex' | 'setQuery' | 'setSuggestions' | 'setIsOpen' | 'setStatus' | 'setContext' | 'ArrowUp' | 'ArrowDown' | 'Escape' | 'Enter' | 'submit' | 'reset' | 'focus' | 'blur' | 'mousemove' | 'mouseleave' | 'click';
export declare type StateEnhancer<TItem> = (state: AutocompleteState<TItem>, props: InternalAutocompleteOptions<TItem>) => AutocompleteState<TItem>;
export {};
